#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <unistd.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>

#include "xmalloc.h"

#define TIMEOUT		10

char * iptos ( unsigned long ip ) {
        struct in_addr s  ;
        s.s_addr = ip ;
        return(strdup (inet_ntoa(s)));
}

void handle_timeout(int sig){
	fprintf(stderr,"- Timeouted.\n");
	exit(-1);
}

int die (char * error) {
        printf("%s",error);
        exit(0xd1e);
}
                
char * trunc(char * str, int bytes) {
	int len;
	char * rt = (char *)xmalloc(bytes+1);
	char *p = strchr(str,'\n');
	*p=0;
	snprintf(rt,bytes,"%s",str);
	len = strlen(rt);
	*(rt + ((bytes > len ) ? len : bytes) )=0;
	return(rt);
}

unsigned long res(char *p) {
   struct hostent *h;
   unsigned long int rv;

   if ((rv=inet_addr(p))!=-1) return rv;
   if((h=gethostbyname(p))!=NULL)  {
        memcpy(&rv,h->h_addr,h->h_length);
        return rv;
   }    
   return(-1);
}

int connect_to_host ( unsigned long ip , int port ) {
  int sockfd ;
  struct sockaddr_in sheep;

  if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) == -1)  {
    perror("socket()");
    return(-1);
  }

  sheep.sin_family = AF_INET;
  sheep.sin_addr.s_addr = ip ;
  sheep.sin_port = htons (port);

  signal(SIGALRM,handle_timeout); alarm(TIMEOUT);
  
  if ( connect(sockfd,(struct sockaddr *)&sheep,sizeof(sheep)) == -1 ) {
	//perror("connect");
	return(-1);
  }
  
  alarm(0); signal(SIGALRM,SIG_DFL);
  return(sockfd);
}

void hexdump(char * str) {
	int count = 0;
	while ( *str ) {
		fprintf(stderr,"[HEX %d]=%x",count++,*str);
		if (count%3)fprintf(stderr,"\n");
		str++;
	}
}

